from django.core.management.base import BaseCommand
from apps.taxonomy.models import TaxonNode, Tree
import time

processCount = 1


def create_taxon(parent, taxon_rank_id, tree):
    epithet = "epithet"
    taxonnode = TaxonNode.objects.create(taxon_rank_id=taxon_rank_id,
                                         tree=tree,
                                         epithet=epithet)
    taxonnode.save()
    taxonnode.post_created(parent=parent)
    return taxonnode


def create_kingdoms(count, tree, stack):
    for _ in range(count):
        stack.append(create_taxon(None, 10, tree))


def add_taxa_to_tree(total, tree):
    count = 8 / processCount
    total = total / processCount
    stack = []

    create_kingdoms(4 / processCount, tree, stack)

    while count < total:
        parent = stack.pop()
        new_taxon_rank_id = parent.taxon_rank_id + 10
        for _ in range(8):
            taxon = create_taxon(parent, new_taxon_rank_id, tree)
            if new_taxon_rank_id < 80:
                stack.append(taxon)
            count = count + 1


class Command(BaseCommand):
    args = '<tree_id total>'
    help = 'Populates given tree with required number of taxa'

    def handle(self, *args, **options):
        # start counting runtime
        if not len(args) == 2:
            print "First two argument must be tree_id and total number of taxa in tree"
        else:
            tree_id = int(args[0])
            tree = Tree.objects.get(pk=tree_id)
            total = int(args[1])
            time_start_total = time.time()
            for i in range(processCount):
                add_taxa_to_tree(total, tree)
            # end here and print out runtime
            print "Everything seemed to work smoothly, will stop here."
            time_end_total = time.time()
            print "Total time taken: %.3f seconds" % \
                  (time_end_total - time_start_total)
